package compilateur.cspLangage;

import java.util.Vector;

import util.Var;

import compilateur.CompilationException;
import compilateur.cspLangage.ListeCommande.VariableItem;


public class CibleArray extends VariableCible {

	public CibleArray(Commande p) {
		super(p);
	}

	public Variable variable;
	public Vector<ExpressionSimple> indices = new Vector<ExpressionSimple>();
	
	@Override
	public String compile(Expression source) throws CompilationException {
		String content = "";
		
		content += compileSimple() + ".set(" + source.compile() + ")";

		return content;
	}

	@Override
	public String compileSimple() throws CompilationException {
		String content = "";
		
		Var item = parent.parent.getVar(variable.toString());
		if (item==null)
			throw new CompilationException (variable.getToken(), "La variable n'a pas t dclare");
		if (!(item.getType() instanceof ArrayType))
			throw new CompilationException (variable.getToken(), "La variable n'est pas un tableau");
		
		content += item.getLinkedVar().getName() + ".getData(";
		
		for (int i=0;i<indices.size();i++) {
			content += indices.get(i).compile();
			if (i != indices.size()-1) content += ", ";
		}
		
		content += ")";
		
		return content;
	}

	@Override
	public String buildCsp() throws CompilationException {
		String content = "";
		
		content += variable.toString () + "[";
		
		for (int i=0;i<indices.size();i++) {
			content += indices.get(i).buildCsp();
			if (i!=indices.size()-1) content += ", ";
		}
		
		content += "]";
		
		
		return content;
	}

	@Override
	public void changeVariable(String oldVar, String newVar) {
		variable.changeVariable (oldVar, newVar);
		for (ExpressionSimple e: indices)
			e.changeVariable(oldVar, newVar);
	}


}
