package compilateur.cspLangage;
import java.util.HashMap;
import java.util.Vector;

import util.Var;
import util.VarAlreadyExistsException;

import compilateur.CompilationException;
import compilateur.CspVar;

import compilateur.cspLangage.ListeCommande.*;

/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Declaration extends Commande {

	public Vector<Variable> variables;
	public Type type;
	public Expression valeur;
	
	public Declaration(ListeCommande parent) {
		this.parent = parent;
	}


	/**
	 * @return
	 * @throws CompilationException 
	 * @throws CompilationException 
	 */
	public String compile() throws CompilationException  {
		String content = "";
		
		/* compilation du type et de la valeur par dfault */
		String compiledValue =  (valeur==null)?type.compileDefaultValueConstructeur():
									valeur.compileConstructeur();
		
		/* commande CSP */
		content += "/* " + buildCsp () + " */\n";
		
		for (Variable v : variables) {
			// declaration de la variable
			// declaration de la variable
						Var var;
			try {
				var = parent.getCspVarList().addLinkedVariable(v.toString(), type, type);
			} catch (VarAlreadyExistsException e) {
				throw new CompilationException (v.getToken(), e.toString());
			}
			//parent.putVariable(v.id.toString(), type, VariableItem.USER, parent.getMacroParent());

			// generation du code (utilisation de CspData)
			content += type.compileDeclaration(var.getLinkedVar().getName());
			content += " = " + compiledValue + ";";
		}

		return content;
	}

	
	public String buildCsp () throws CompilationException {
		String content = "";
		
		for (int i=0;i<variables.size();i++) {
			content += variables.get(i).toString();
			if (i!=variables.size()-1) content += ", ";
		}
		
		content += " : " + type.buildCsp ();
		
		if (valeur!=null) content += " := " + valeur.buildCsp ();
		
		return content;
		
	}


	@Override
	public void changeVariable(String oldVar, String newVar) {
		if (variables != null)
			for (Variable v : variables) 
				v.changeVariable(oldVar,newVar);
		if (type!=null) type.changeVariable(oldVar,newVar);
		if (valeur!=null) valeur.changeVariable(oldVar,newVar);
	}
	
}
