package compilateur.cspLangage;

import java.util.Vector;

import util.Var;
import util.VarManager;

import compilateur.CompilationException;
import compilateur.CspVar;
import compilateur.CspVarManager;
import compilateur.Tool;

import antlr.Token;


public class ListeCommande  extends LangageToken {

	public static class VariableItem {
		public final static int COMPILATEUR = 0;
		public final static int USER = 1;
		String name;
		Type type;
		public Macro parent;
				
		int type_def;
		int level = 0;
		
		public VariableItem (String name, int type_def, Macro parent) {
			this.name = name;
			this.type_def = type_def;
			this.parent = parent;
		}
	
		public VariableItem (String name, Type type, int type_def, Macro parent) {
			this.name = name;
			this.type = type;
			this.parent = parent;
			this.type_def = type_def;
		}
	}
	//private Vector<VariableItem> listeVariable = new Vector<VariableItem> ();
	
	private CspVarManager cspVarList = new CspVarManager ();	
	
	/*
	 * Liste des commandes
	 */
	Vector<Commande> liste = new Vector<Commande> ();
	
	/*
	 * liste parente
	 */
	public ListeCommande listeParent=null;
	public Macro parentMacro = null;
		
	public ListeCommande(Macro parent) {
		parentMacro = parent;
		cspVarList.setLinkedManager (parent.getJavaVarList());
	}
	
	public ListeCommande(ListeCommande parent) {
		listeParent = parent;
		cspVarList.setParentManager (parent.getCspVarList());
	}

	/*public VariableItem searchVariableItem (String name) {
		for (VariableItem vi : listeVariable) {
			if (vi.name.equals(name)) return vi;
		}
		VariableItem item = (listeParent==null)?null:listeParent.searchVariableItem(name);
	 	
		return item;
	}*/
	
	public CspVar getVar (String name) {
		CspVar v = cspVarList.searchVar(name);
		if (v==null) return null;
		
		if (!(v.getType() instanceof TypeDefine)) 
			if (v.getLinkedVar().getParent()!=cspVarList.getLinkedManager())
				getMacroParent().putVariableExterne(v);
		
		return v;
	}
	
	/*public VariableItem getVariableItem (String name) {
		for (VariableItem vi : listeVariable) {
			if (vi.name.equals(name)) return vi;
		}
		VariableItem item = (listeParent==null)?null:listeParent.getVariableItem(name);
	 	
		if (item!=null) {
			if (!(item.type instanceof TypeDefine))
				if (item.parent!= getMacroParent())
					getMacroParent().putVariableExterne(item.name);
		}
		
		return item;
	}*/
	
	public Macro getMacroParent () {
		return (parentMacro!=null)? parentMacro : listeParent.getMacroParent();
	}
	
	/*public void putVariable (String name, Type type, int type_def, Macro parent) {
		VariableItem item = new VariableItem(name, type, type_def, parent);
		listeVariable.add (item);
	}*/
	
	
	public void add(Commande c) {
		liste.add (c);
	}

	public void preCompile() {
		for (Commande cmd : liste) {
			cmd.preCompile();
		}
	}

	public String compile() throws CompilationException {

		String content = "";
		for (Commande cmd : liste) {
			cmd.parent = this;
			content += "if (debug (new DebugObj(" + cmd.firstToken.getLine() + ", ";
			content += cmd.firstToken.getColumn() + ", ";
			content += cmd.lastToken.getLine () + ", ";
			content += (cmd.lastToken.getColumn()+cmd.lastToken.getText().length()-1) + "))) break;\n";
			content += cmd.compile () + "\n";
		}
		
		return content;
	}

	/*public String obtainVariable (String base) {
		String name = base;
		while (searchVariableItem(name)!=null) name = Tool.createNewName(name);
		return name;
	}*/

	public void changeVariable (String oldVar, String newVar) {
		for(Commande cmd : liste) {
			cmd.changeVariable (oldVar, newVar);
		}
	}

	public Token getFirstToken () {
		return liste.get(0).firstToken;
	}
	
	public Token getLastToken () {
		return liste.get(liste.size()-1).lastToken;
	}
	
	public CspVarManager getCspVarList () { return cspVarList; }
}
