package compilateur.cspLangage;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Vector;

import compilateur.*;
import compilateur.cspLangage.ListeCommande.VariableItem;

import util.UTF_FileOutputStream;
import util.Var;
import util.VarManager;

import static compilateur.cspLangage.ListeCommande.VariableItem.*;


/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Macro  extends LangageToken {

	public boolean compiled = false;
	
	public static String dir;
	
	/*
	public static class SuperListeCommand extends ListeCommande {
		
		public SuperListeCommand() {
			super(null);
			// TODO Auto-generated constructor stub
		}

		VariableItem [] listeVariable = new VariableItem [] {
				new VariableItem("public", COMPILATEUR, null),	
				new VariableItem("protected", COMPILATEUR, null)
				};
		
		public VariableItem getVariableItem (String name) {
			for (VariableItem vi : listeVariable) {
				if (vi.name.equals(name)) return vi;
			}
			return null;
		}
		
		public Macro getMacroParent () {
			return null;
		}
	}
	*/
	public int level = 0;
	//public ListeCommande parent = new SuperListeCommand();
	
	public JavaVarManager javaVarList = new JavaVarManager ();

	public Vector<CspVar> variablesExternes = new Vector<CspVar>();
	
	public Macro parentMacro = null;
	
	// post analyse syntaxique
	private ListeCommande liste;
	public Identifier id;
	
	// post analyse smantique
	public String preparedId;
	public Vector<IndiceLabel> indices;
	
	public void putVariableExterne(CspVar var) {
		if (variablesExternes.contains(var)) return;
		
		variablesExternes.add (var);
		
		/*for (String n : variablesExternes)
			if (n.equals(name)) return;
		variablesExternes.add (name);*/
	}

	
	public void preCompile() {
		liste.preCompile ();
		
	}

	public JavaVarManager getJavaVarList () { return javaVarList; }
	
	public void compile (String intoBody) throws CompilationException {
		
		compiled = true;
		
		//liste.listeParent = parent;
		//liste.getCspVarList().setLinkedManager(javaVarList);
		//liste.parentMacro = this;
		
		// package
		String packageDeclaration = "package " + dir + ";";
		
		// dclaration des imports
		String imports = "";
		imports += "import csp_runtime.*;\n";

		// token bounds
		String tokenBoundsContent = "setThreadBounds (";
		tokenBoundsContent += liste.getFirstToken().getLine() + ", ";
		tokenBoundsContent += liste.getFirstToken().getColumn() + ", ";
		tokenBoundsContent += liste.getLastToken().getLine() + ", ";
		tokenBoundsContent += (liste.getLastToken().getColumn() + liste.getLastToken().getText().length()-1) + ");\n";
		
		// setCompleteNameIndices
		String setCompleteNameIndices = "";
		
		// variables d'instance
		String variables = "";
		
		// compilation des indices ventuel et dclaration 
		String indiceParams = "";
		String indiceInsideCons = "";
		int i = 0;
		if (indices!=null) {
			for (IndiceLabel indice : indices) {
				CspVar var = liste.getCspVarList().addLinkedVariable(indice.range.variable.toString(), new TypeSimple("integer", "0"), new TypeSimple("int", "0"));
				String indiceName = var.getLinkedVar().getName();
				//liste.putVariable(indiceName, new TypeSimple ("int","0"), VariableItem.USER, this);
				indiceParams += ", int " + indiceName;
				if (i != 0)setCompleteNameIndices += ", "; 
				setCompleteNameIndices += indiceName;
				variables += "final int " + indiceName + ";\n";
				indiceInsideCons += "this." + indiceName + " = " + indiceName + ";\n";
				i++;
			}
		}
		
		// run
		String runContent = "";
		runContent += "public void run () {\n";
		runContent += "try {\n";
		runContent += "while (true) {\n";
		runContent += liste.compile () +"\n";
		runContent += "success = true;\n";
		runContent += "break;\n";
		runContent += "}\n";
		runContent += "} catch (Exception e) {\n";
		runContent += "print (\"Terminaison exceptionnelle : <\" + getName() + \">\" + e.toString() + \"\\n\");\n";
		runContent += "}\n";
		runContent += "\nfireDeath();\n";
		runContent += "}\n";

		for (CspVar var : variablesExternes) {
			// on vrifie que la variable dsire est dans le macro super.
			// sinon, on l'y dclare externe.
			
			if (var.getLinkedVar().getParent()!=parentMacro.getJavaVarList())
				parentMacro.putVariableExterne(var);
			
			Type type = var.getLinkedVar().getType();
			String decl = type.compileDeclaration(var.getLinkedVar().getName());
			variables +=  decl + ";\n";
			if (!(type instanceof TypeProcessus)) {
				indiceParams += ", " + decl;
				indiceInsideCons += "this." + var.getLinkedVar() + " = " + var.getLinkedVar() + ";\n";
			}
		}
		
		// constructeur
		String constructeurContent = "";
		constructeurContent += "public " + id.toString() + "(String name" + indiceParams + ") {\n";
		constructeurContent += "super (name);\n";
		constructeurContent += indiceInsideCons;
		constructeurContent += tokenBoundsContent;
		constructeurContent += "setCompleteName(" + setCompleteNameIndices + ");\n";
		constructeurContent += "}\n";

		// setVariables - variables externes
		String setVariablesContent = "";
		String setVariablesBody = "";
		setVariablesContent += "public void setVariables(";
		String setVariablesParams = null;

		for (Var var : variablesExternes) {
			Type type = var.getLinkedVar().getType();
			if (type instanceof TypeProcessus) {
				String decl = type.compileDeclaration(var.getLinkedVar().getName());
				if (setVariablesParams == null) 
					setVariablesParams = decl;
				else
					setVariablesParams += "," + decl;
					
				setVariablesBody += "this." + var.getLinkedVar() + " = " + var.getLinkedVar() + ";\n";
			}
		}
		
		setVariablesContent += (setVariablesParams==null)?"":setVariablesParams;
		setVariablesContent += ") {\n";
		setVariablesContent += setVariablesBody;
		setVariablesContent += "}\n";
		
		// classContent
		String classContent = "";
		classContent += "public class " + id.toString () +  " extends CspThread {\n";
		classContent += variables + "\n";
		classContent += constructeurContent + "\n";
		classContent += setVariablesContent + "\n";
		classContent += runContent + "\n";
		classContent += intoBody +  "\n";
		classContent += "}\n";
		
			
		String fileContent = "";
		fileContent += packageDeclaration + "\n";
		fileContent += imports + "\n";
		fileContent += classContent + "\n";
		
		try {
			Tool.newJavaFile(dir, id.toString()+".java", fileContent);
		} catch (IOException e) {
			throw new CompilationException (e);
		}
	}
	
	/**
	 * @param dir
	 * @param declarations
	 * @throws IOException 
	 */
	public void compileMain(String dir) throws CompilationException {
		
		// dclaration d'une mthod 'main'
		String mainMethod = "";
		mainMethod += "public static void main (String args []) {\n";
		mainMethod += "new MAIN (\"main\").start();\n";
		mainMethod += "}\n";
		
		Macro.dir = dir;
		compile (mainMethod);
	}

	public void compile() throws CompilationException {
		// TODO Auto-generated method stub
		compile ("");
	}
	
	public ListeCommande getListe () { return liste;}
	
	public void setListe (ListeCommande liste) { 
		this.liste = liste;  
		//liste.getCspVarList().setLinkedManager(javaVarList);
		
	}
}
