package compilateur.cspLangage;
import java.util.Vector;

import compilateur.CompilationException;
import compilateur.CspVar;
import compilateur.cspLangage.ListeCommande.VariableItem;


/*
 * Created on 18 mai 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Administrateur
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ProcessusCible  extends LangageToken {

	public Identifier nomProcessus;
	public Vector<ExpressionSimple> listeIndice;
	public Commande parent;
	
	public ProcessusCible(Commande parent) {
		this.parent  = parent;
	}

	public String compile() throws CompilationException {
		String content = "";
		
		// vrification de l'existence du processus et rcupration de l'indicage
		CspVar procVar = parent.parent.getVar(nomProcessus.toString());
		//VariableItem item = parent.parent.getVariableItem(nomProcessus.toString());
		if (procVar==null || !(procVar.getType() instanceof TypeProcessus)) 
			throw new CompilationException (nomProcessus.token, "Ce processus n'a pas t dfini");
		
		TypeProcessus type = (TypeProcessus) procVar.getType();
		// vrification de l'indicage
		if ((type.p.label.listeIndice==null && listeIndice!=null)
				|| (type.p.label.listeIndice != null && listeIndice==null))
			throw new CompilationException (nomProcessus.token, "l'indicage ne correspond pas");

		content += procVar.getLinkedVar().getName();
		if (listeIndice !=null) {
			if (type.p.label.listeIndice.size()!=listeIndice.size())
				throw new CompilationException (nomProcessus.token, "l'indicage ne correspond pas");
			for (int i=0;i<listeIndice.size();i++) {
				content += "[";
				content += compileIndice (listeIndice.get(i), type.p.label.listeIndice.get(i));
				content += "]";
			}
		}
		
		return content;
	}

	private String compileIndice(ExpressionSimple simple, IndiceLabel label) throws CompilationException {
		return simple.compile() + " - " + label.range.borneInf.compile();
	}

	public void changeVariable(String oldVar, String newVar) {
		nomProcessus.changeVariable (oldVar, newVar);
		if (listeIndice!=null)
			for (ExpressionSimple e : listeIndice)
				e.changeVariable(oldVar, newVar);
	}

	public String buildCsp() throws CompilationException {
		String csp  ="";
		
		csp += nomProcessus.toString();
 		
		if (listeIndice != null && listeIndice.size() >0) {
			csp += "[";
			for (int i=0;i<listeIndice.size();i++) {
				if (i!=0) csp += ", ";
				csp += listeIndice.get(i).buildCsp();
			}		
			csp += "]";
		}
		return csp;
	}
	
		
	
}
