package compilateur.cspLangage;

import java.util.HashMap;

import antlr.Token;

public class SimpleType extends Type {

	public static HashMap<String,String[]> typeMap = new HashMap<String,String[]> ();
	static {
		// initialisation de la map
		typeMap.put("integer", new String[]{"Integer", "0"});
		typeMap.put("string",  new String[]{"String", "\"\""});
		typeMap.put("boolean", new String[]{"Boolean", "false"});
		
	}
	
	Identifier id;
	public Commande parent;
	
	public SimpleType (String t) {
		id = new Identifier (t);
	}
	
	public SimpleType(Token t1, Commande parent) {
		id = new Identifier ();
		id.token = t1;
		this.parent = parent;
	}

	public String compile () {
		String [] tab = typeMap.get(id.toString());
		return (tab==null)?id.toString():tab[0];
	}
	
	public String getDefaultValue () {
		String [] tab = typeMap.get(id.toString());
		return (tab==null)?"null":tab[1];
	}

	@Override
	public String compileDeclaration(String var) {
		String content = "";
		
		content += "final CspData<" + compile () + "> " + var;
		
		return content;		
	}

	@Override
	public String compileDefaultValueConstructeur() {
		String content = "";
		
		content += "CspData.newCspData(" + getDefaultValue() + ")";
		
		return content;
	}

	@Override
	public String compileAffect(String var, String contentSource) {
		return var + ".set(" + contentSource + ")";
	}

	@Override
	public String buildCsp() {
		return id.toString();
	}

	@Override
	public String compileGet(String var) {
		return var + ".get()";
	}

	@Override
	public void changeVariable(String oldVar, String newVar) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean equals(Type t) {
		if (t instanceof SimpleType) {
			if (((SimpleType)t).id.toString().equals(id.toString()))
				return true;
		}
		return false;
	}
}
