package ihm.compilateur;

import java.awt.Font;
import java.io.IOException;
import java.io.OutputStream;

import javax.swing.*;

/**
 * MsgArea fournit une zone de texte ddie  l'affichage des erreurs.
 * 
 * @author Benjamin LE BOZEC
 *
 */
public class MsgArea extends JScrollPane {

	public static final Font defaultFont = new Font ("courier new", 0, 12);
	JTextArea area = new JTextArea ();
	OutputStream out;
	
	
	public MsgArea () {
		super ();
		
		setViewportView (area);
		area.setFont (defaultFont);

		out = new OutputStream () {
		
			@Override
			public void write(int b) throws IOException {
				append ("" + (char) b);
			}
		
			@Override
			public void write(byte[] b) throws IOException {
				append (new String (b));
			}
		
		};
		
		area.setEditable (false);
	}
	
	public void append (String str) {
		area.append (str);
	}
	
	public void append (Exception e) {
		area.append(e.toString() + "\n");
	}
	
	public void clean () {
		area.setText ("");
	}

	public void appendln(String string) {
		append (string + "\n");
	}

	public OutputStream getOutputStream() {
		return out;
	}
}

