package ihm.runtimeIhm;


import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;

import csp_runtime.CspThread;
import csp_runtime.EndThreadListener;
import csp_runtime.NewThreadListener;

/**
 * JListThread correspond  la liste de processus prsente sur la gauche de la 
 * fenetre de dbuggage.
 *  
 * @author Benjamin LE BOZEC
 */
public class JListThread extends JScrollPane {

	private static class JListThreadRenderer implements ListCellRenderer {

		public JPanel panel = new JPanel();
		public JLabel label = new JLabel();
		
		public JListThreadRenderer () {
			panel.setLayout(new GridLayout());
			panel.add (label);
		}
		
		public Component getListCellRendererComponent(
				JList list, 
				Object value, 
				int index, 
				boolean isSelected, 
				boolean cellHasFocus) {
			CspThread thread = (CspThread) value;
			label.setText(thread.getCompleteName());			
			return panel;
		}
		
	}
	
	private DebugWindow debugWindow;
	
	private DefaultListModel model = new DefaultListModel ();
	private JList list = new JList (model);
	
	public JListThread (DebugWindow debugWindow) {
		this.debugWindow = debugWindow;
		
		setViewportView (list);
		CspThread.addNewThreadListener (new NewThreadListener() {
			public void newThread(CspThread nouv) {
				model.addElement(nouv);
			}
		});
		
		CspThread.addEndThreadListener (new EndThreadListener() {
			public void endThread(CspThread thread) {
				try {
					model.removeElement (thread);
				} catch (ArrayIndexOutOfBoundsException e) {
				}
			}
		});
		
		/*
		 * Config gnrale
		 */
		setPreferredSize(new Dimension(100, 150));
	}

	public CspThread [] getSelectedThreads() {
		 Object [] tab = list.getSelectedValues();
		 CspThread [] result = new CspThread [tab.length];
		 for (int i =0;i<tab.length;i++)
			 result[i] = (CspThread) tab[i];
		 return result;
	}

	public JList getList() {
		return list;
	}
	
}
