package ihm.runtimeIhm;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Point;
import java.beans.PropertyVetoException;

import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;

/**
 * ThreadDesktop est un JDesktopPane adapt aux threads CSP.
 * @author irccyn
 *
 */
public class ThreadDesktop extends JDesktopPane {

	private static final int decalage = 20;
	private DebugWindow debugWindow;
	private static final Dimension defaultFrameSize = new Dimension (300, 200);
	
	public ThreadDesktop (DebugWindow debugWindow) {
		this.debugWindow = debugWindow;
		
	}

	public void putIntoDesktop (JInternalFrame frame) {
		remove(frame);
		Point p = new Point(0, 0);
		while (checkLocation (p)) p.translate (decalage, decalage);
		frame.setLocation(p);
		frame.setVisible(true);
		frame.setSize(defaultFrameSize);
		add (frame);
		try {
			frame.setSelected(true);
		} catch (PropertyVetoException e) {
		}
	}

	/**
	 * Vrifie si la position de fenetre est dja oqp par une autre fenetre
	 * @param location
	 * @return VRAI si une autre fenetre se situe dja en 'location', FAUX sinon
	 */
	private boolean checkLocation(Point location) {
		Component [] tab = getComponents();
		for (Component c : tab)
			if (c.getLocation().equals(location)) return true;
		return false;
	}
	
	public void layoutFrames () {
		int nbComp = getComponentCount();
		setLayout (new GridLayout(2,(nbComp - (nbComp%2))/2));
		validate ();
		setLayout (null);
	}

	public void addFrame(JInternalFrame console) {
		putIntoDesktop(console);
	}
}
