package util;

import java.io.IOException;
import java.io.InputStream;

/**
 * PipeStream rcupe un flux et le renvoie sur une autre mthode
 * sous forme de chaine de caracteres.
 * @author Benjamin LE BOZEC
 */
public abstract class PipeStream implements Runnable {

	private InputStream input;
	
	public PipeStream (InputStream input, boolean newProc) {
		this.input = input;
		if (newProc) {
			new Thread(this).start();
		} else {
			run();
		}
	}
	
	public void run () {
		byte [] buffer = new byte[1024];
		int lus;
		try {
			while ((lus=input.read(buffer))!=-1) {
				write(new String(buffer, 0, lus)); 
			}
		} catch (IOException e) {
			reportError (e);
		}
	}
	
	
	public abstract void reportError (IOException e);
	public abstract void write (String str);
	
}
