 /*
 * Created on 8 fvr. 2005
 *
 * 25/02/05 - Changement de la structure, cration de OutputSaveObject et InputSaveObject
 */
package util.saveObject;

import java.util.LinkedList;

/**
 * Cette classe gnralise les 2 classes "OuputSaveObject" et "InputSaveObject".
 * Elle ne peut tre instancie directement par l'utilisateur. 
 * Pour sauvegarder des objets , utiliser "OuputSaveObject", 
 * pour les rcuprer utiliser "InputSaveObject".
 * 
 * @author Benjamin LEBOZEC
 */
public class SaveObject {

	/*
	 * Liste d'ElemSaveObject.
	 * C'est dans cette liste que sont conservs les images des objets.  
	 */
	protected LinkedList data;
	
	/*
	 * isRacine est un boolen indiquant si le SaveObject courant est 
	 * la racine des objets  sauvegarder.
	 */
	protected boolean isRacine = false;
	
	/**
	 * Unique constructeur. Ne doit tre appel que par OutputSaveObject et InputSaveObject
	 */
	protected SaveObject () {
		data = new LinkedList ();
	}
	
	/**
	 * Teste si la classe donne en paramtre fait partie des classes primitives :
	 * Boolean, byte, character, Short, Integer, Long, Float, Double, Void, String.
	 * La classe "String" n'est pas considre comme primitive par Java, mais
	 * a quand mme t rajout pour des raisons de simplicit.
	 * 
	 * @param c la classe a tester
	 * @return VRAI si la classe est primitive, faux sinon
	 */
	protected static boolean isPrimitive (Class c) {
        if (c == Boolean.class)   return true;
        if (c == Byte.class)      return true;
        if (c == Character.class) return true;
        if (c == Short.class)     return true;
        if (c == Integer.class)   return true;
        if (c == Long.class)      return true;
        if (c == Float.class)     return true;
        if (c == Double.class)    return true;
        if (c == Void.class)      return true;
        if (c == String.class)    return true;
        return false;
	}
	
}

/**
 * Cette classe permet d'englober toutes les proprits d'un lment (ou objet)
 * name : nom de l'lement;
 * value : contenu de l'lment (Peut etre soit un String, soit un SaveObject);
 * className : la classe de l'lment;
 * reference : une rfrence ventuelle si l'objet est dja dans l'arbre des SaveObject.
 * 
 * @author Benjamin LE BOZEC
 */
class ElemSaveObject {
	String name;
	Object value;
	String className;
	String reference;
}
