/*
 * Created on 23 fvr. 2005
 */
package util.saveObject;

import java.util.*;

/**
 * <p>Cette classe est utilise par XmlWriter pour englober les proprits 
 * d'une balise XML sous la forme du liste. Les lments stocks sont 
 * donc des couples (String nom, String value).
 * 
 * @author Benjamin LE BOZEC
 */
public class XmlPropertyList {

	/**
	 * Classe englobant un lment, cad un couple (nom, valeur) 
	 * @author Benjamin LE BOZEC
	 */
	class Item {
		String name;
		String value;
	}
	
	/*
	 * Liste chaine listant les proprits
	 */
	private LinkedList list;
	
	/**
	 * Cr une nouvelle instance de XmlPropertyList
	 */
	public XmlPropertyList () {
		list = new LinkedList ();
	}
	
	/**
	 * Ajout d'une proprit a la liste
	 * @param name nom de la proprit
	 * @param value valeur de la proprit
	 */
	public void add (String name, String value) {
		Item item = new Item ();
		item.name = name;
		item.value = value;
		list.addLast(item);
	}
	
	/**
	 * @return le nombre de proprits que la liste contient
	 */
	public int size () {
		return list.size ();
	}
	
	/**
	 * <p>Retourne la proprit qui a pour index 'index' sous la forme :
	 * <code>name="valeur"</code> 
	 * @param index
	 * @return la chaine de caractre ainsi cre
	 */
	public String getProperty (int index) {
		String attr = "";
		Item item = (Item) list.get(index);
		attr = item.name + "=\"" + item.value + "\""; 		
		return attr;
	}
	
	/**
	 * Retire l'ensemble des proprits que la liste contient
	 */
	public void flush () {
		list.clear();
	}
}
